---------Unreal Death by Unrealrules-Eredar ----------
-- Bugs: Hunter: Todstellen



PvPGrid = LibStub("AceAddon-3.0"):NewAddon("PvPGrid", "AceEvent-3.0","AceConsole-3.0","AceTimer-3.0")

local media = LibStub("LibSharedMedia-3.0")
--local L = LibStub("AceLocale-3.0"):GetLocale("UnrealDeath")
PvPGrid:Print("Hi new Grid Addon")

function PvPGrid:OnInitialize()
	--UnrealDeath.db = LibStub("AceDB-3.0"):New("UnrealDeathDB", UnrealDeath.data.dbDefaults)
	-- UnrealDeath.data = {}
	-- UnrealDeath.data.localdeaths = {}
	-- -- UnrealDeath.data.localdeaths.creature = {}
	-- -- UnrealDeath.data.localdeaths.pet = {}
	-- -- UnrealDeath.data.localdeaths.gameobject = {}
	-- -- UnrealDeath.data.localdeaths.vehicle = {}
	-- -- UnrealDeath.data.localdeaths.player = {}
	-- UnrealDeath.playerdeathsdata = {}
	-- UnrealDeath:clear_playerdeathdata()
end

function PvPGrid:OnEnable()
	
	self.playergrid = {}
	self:createdisplay()
	
	self.playerinfos = {}
	-- self:get_Location()
	-- UnrealDeath.playerdeaths_counts = {}
	self.mainframe:RegisterEvent('ZONE_CHANGED_NEW_AREA')
	self.mainframe:RegisterEvent('UPDATE_BATTLEFIELD_SCORE')
	self.mainframe:RegisterEvent('UNIT_TARGET')
	-- self.mainframe:RegisterEvent('COMBAT_LOG_EVENT_UNFILTERED')
	
	self.mainframe:SetScript('OnEvent', PvPGrid_OnEvent)
end

function PvPGrid:createdisplay()
	self:create_mainframe()
	self:create_playerframes()
	self:showgrid()
end

function PvPGrid:create_mainframe()
	PvPGrid.mainframe = CreateFrame("Frame", 'MainFrame', UIParent)
	PvPGrid.mainframe:SetPoint("Center", 0, 300)
	PvPGrid.mainframe:SetSize(150, 35)
	PvPGrid.mainframe:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8", tile = true, tileSize = 8 })
	PvPGrid.mainframe:SetBackdropColor(0.5, 0.5, 0.5, 0.3)
	PvPGrid.mainframe:SetMovable(true)
	PvPGrid.mainframe:EnableMouse(true)
	PvPGrid.mainframe:RegisterForDrag("LeftButton")
	PvPGrid.mainframe:SetScript("OnDragStart", PvPGrid.mainframe.StartMoving)
	PvPGrid.mainframe:SetScript("OnDragStop", PvPGrid.mainframe.StopMovingOrSizing)
	PvPGrid.mainframe.fontname = PvPGrid.mainframe:CreateFontString(nil, "OVERLAY", "GameTooltipText")
	PvPGrid.mainframe.fontname:SetPoint("TOPLEFT", 0, 0)
	PvPGrid.mainframe.fontname:SetText('PvPGrid')
	PvPGrid.mainframe.fontname:SetTextColor(1, 1, 1, 0.6)
	PvPGrid.mainframe.fontname:SetFont("Fonts\\FRIZQT__.ttf" , 10, "OUTLINE")
end

function PvPGrid:create_playerframes()
	local height = 15
	for i=1, 15, 1 do
		local framename = 'enemyplayer'..i
		self.mainframe[framename] = CreateFrame("Button", framename, self.mainframe, "SecureActionButtonTemplate")
		self.mainframe[framename]:SetPoint("TOPLEFT", 0, -10-(i-1)*height)
		self.mainframe[framename]:SetSize(150 , height)
		--self.mainframe[framename]:SetBackdrop({ bgFile = "Interface\\BUTTONS\\WHITE8X8"})
		--self.mainframe[framename]:SetBackdropColor(0.1*(i-1), 0, 0, 0.5)
		self.mainframe[framename]:RegisterForClicks("AnyUp")
		self.mainframe[framename]:SetAttribute("type1", "macro")
		self.mainframe[framename]:SetAttribute("macrotext1", "")
		--self.mainframe[framename]:SetMinMaxValues(0, 1)
		
		self.mainframe[framename].health = CreateFrame('StatusBar', nil, self.mainframe[framename])
		self.mainframe[framename].health:SetPoint('CENTER', 0, 0)
		self.mainframe[framename].health:SetSize(150 , height)
		self.mainframe[framename].health:SetStatusBarTexture('Interface/Buttons/GreyscaleRamp64')
		self.mainframe[framename].health:SetBackdrop({
			bgFile = "Interface/Buttons/GreyscaleRamp64",
			edgeFile = "Interface/Buttons/WHITE8X8",
			edgeSize = 1,
		});
		self.mainframe[framename].health:SetBackdropBorderColor(1,1,1,1);
		self.mainframe[framename].health:SetBackdropColor(0.1*(i-1), 0, 0, 0.5)
		self.mainframe[framename].health:SetMinMaxValues(0, 1)
		self.mainframe[framename].health:SetValue(0.5)
		self.mainframe[framename].health:SetStatusBarColor(1,1,1,1);
		self.mainframe[framename].health:SetFrameStrata('LOW')
	
		self.mainframe[framename].fontname = self.mainframe[framename]:CreateFontString(nil, "OVERLAY", "GameTooltipText")
		self.mainframe[framename].fontname:SetPoint("LEFT", height*2+2, 0)
		self.mainframe[framename].fontname:SetText(i)
		self.mainframe[framename].fontname:SetTextColor(1, 1, 1)
		self.mainframe[framename].fontname:SetFont("Fonts\\FRIZQT__.ttf" , 10, "OUTLINE")
		self.mainframe[framename].roleicon = self.mainframe[framename]:CreateTexture(nil, "OVERLAY")
		self.mainframe[framename].roleicon:SetPoint("TOPLEFT", -height*2-2, 0)
		self.mainframe[framename].roleicon:SetSize(height , height)
		self.mainframe[framename].roleicon:SetTexture([[Interface\LFGFRAME\UI-LFG-ICON-ROLES]])
		self.mainframe[framename].roleicon:SetTexCoord(0, 0.25, 0.5, 0.75)
		self.mainframe[framename].specicon = self.mainframe[framename]:CreateTexture(nil, "OVERLAY")
		self.mainframe[framename].specicon:SetPoint("TOPLEFT", -height-1, 0)
		self.mainframe[framename].specicon:SetSize(height , height)
		self.mainframe[framename].specicon:SetTexture([[Interface\ICONS\Trade_Engineering]])
		self.mainframe[framename]:Hide()
	end
end

function PvPGrid:updategrid()
	for i=1, 15, 1 do
		local framename = 'enemyplayer'..i
		self.mainframe[framename]:Hide()
		if not self.playergrid[i] then
			return
		end
		self.mainframe[framename]:Show()
		self.mainframe[framename].fontname:SetText(self.playergrid[i].name)
		for j = 1, #PvPGrid.Classinfos[self.playergrid[i].class] do
			if self.playergrid[i].spec == PvPGrid.Classinfos[self.playergrid[i].class][j].specname then
				--print(self.playergrid[i].name..' is '..self.playergrid[i].spec)
				self.mainframe[framename].specicon:SetTexture(PvPGrid.Classinfos[self.playergrid[i].class][j].specicon)
				if PvPGrid.Classinfos[self.playergrid[i].class][j].specrole == "DAMAGER" then
					self.mainframe[framename].roleicon:SetTexCoord(0.25, 0.5, 0.25, 0.5)
				elseif PvPGrid.Classinfos[self.playergrid[i].class][j].specrole == "HEALER" then
					self.mainframe[framename].roleicon:SetTexCoord(0.25, 0.5, 0, 0.25)
				elseif PvPGrid.Classinfos[self.playergrid[i].class][j].specrole == "TANK" then
					self.mainframe[framename].roleicon:SetTexCoord(0, 0.25, 0.25, 0.5)
				else
					self.mainframe[framename].roleicon:SetTexCoord(0, 0.25, 0.5, 0.75)
				end
				local classColor = self.playergrid[i].class and RAID_CLASS_COLORS[self.playergrid[i].class] or NORMAL_FONT_COLOR;	
				self.mainframe[framename].health:SetBackdropColor(classColor.r, classColor.g, classColor.b, 0.5)
				self.mainframe[framename].health:SetStatusBarColor(classColor.r, classColor.g, classColor.b, 1)
			end
		end
		if not InCombatLockdown() then
			self.mainframe[framename]:SetAttribute('macrotext1',
				'/cleartarget\n'..
				'/targetexact '..self.playergrid[i].name
			);
		end
	end
end

function PvPGrid:default_players()
	self.playergrid = {}
	for i=2, 10, 1 do
		self.playergrid[i] = {}
	end
	self.playergrid[1] = {
		name = 'Rivah',
		class = 'MAGE',
		spec = 'Arkan',
		maxhealth = 1,
	}
	self.playergrid[2] = {
		name = 'Armicron',
		class = 'DRUID',
		spec = 'Wildheit',
		maxhealth = 1,
	}
	self.playergrid[3] = {
		name = 'Wyrlinia',
		class = 'DRUID',
		spec = 'Wächter',
		maxhealth = 1,
	}
	self.playergrid[4] = {
		name = 'Deex',
		class = 'MAGE',
		spec = 'Feuer',
		maxhealth = 1,
	}
	self.playergrid[5] = {
		name = 'Trakoda',
		class = 'SHAMAN',
		spec = 'Elementar',
		maxhealth = 1,
	}
	self.playergrid[6] = {
		name = 'Sid',
		class = 'WARLOCK',
		spec = 'Zerstörung',
		maxhealth = 1,
	}
	self.playergrid[7] = {
		name = 'Unrealrules',
		class = 'PRIEST',
		spec = 'Heilig',
		maxhealth = 1,
	}
	self.playergrid[8] = {
		name = 'Awakening',
		class = 'HUNTER',
		spec = 'Treffsicherheit',
		maxhealth = 1,
	}
	self.playergrid[9] = {
		name = 'Groni',
		class = 'PALADIN',
		spec = 'Vergeltung',
		maxhealth = 1,
	}
	self.playergrid[10] = {
		name = 'Musclebrah',
		class = 'ROGUE',
		spec = 'Meucheln',
		maxhealth = 1,
	}
end

PvPGrid.Classinfos = {}

for i = 1, MAX_CLASSES do
	local _, classnumber = GetClassInfoByID(i)
	local specnumbers = GetNumSpecializationsForClassID(i)

	PvPGrid.Classinfos[classnumber] = {}
	for j = 1, specnumbers do
		local _,name,_,icon,role = GetSpecializationInfoForClassID(i, j)
		PvPGrid.Classinfos[classnumber][j] = {specname = name, specicon = icon, specrole = role}
	end
end


function PvPGrid:update_playerinfo()
	local playernumbers = GetNumBattlefieldScores()
	PvPGrid.playergrid = {}
	local j = 1
	for i = 1, playernumbers do
		local name,_,_,_,_,faction,_,_,class,_ ,_,_,_,_,_,spec = GetBattlefieldScore(i)
	
		if faction == 1 then
			--print(UnitGUID(name))
			PvPGrid.playergrid[j] = {}
			PvPGrid.playergrid[j] = {
				name = name,
				class = class,
				spec = spec,
				maxhealth = 1,
				guid = '',
			}
			j = j +1
		end
		
		--print(name..': '..class..' '..spec..' '..faction)
	end
end

function PvPGrid:showgrid()
	PvPGrid:default_players()
	PvPGrid:update_playerinfo()
	PvPGrid:updategrid()
	
end

function PvPGrid:PvP_Zone_check()
	local _, area = IsInInstance()
	if area == "pvp" then
		PvPGrid:onBG()
	end
end

function PvPGrid:onBG()
	PvPGrid:showgrid()
end

function PvPGrid:target_check(...)
	local unit = (...)
	local targetunit = unit..'target'
	local targetguid = UnitGUID(targetunit)
	if targetguid ~= nil then
		local targetname, targetserver = UnitFullName(targetunit)
		if targetserver == nil then
		
		else
			targetname = targetname..'-'..targetserver 
		end
		local type, zero, server_id, instance_id, zone_uid, npc_id, spawn_uid = strsplit("-",targetguid);
		if type == 'Player' then
			--print('target is '..targetname)
			if PvPGrid.playerinfos[targetname] == nil then --insert
				PvPGrid.playerinfos[targetname] = {}
				PvPGrid.playerinfos[targetname].guid = targetguid
				PvPGrid:update_health(targetunit)
			else --update
				PvPGrid:update_health(targetunit)
			end
		end
	end
end

function PvPGrid:update_health(unit, ...)
	local targetguid = UnitGUID(unit)
	if targetguid ~= nil then
		local targetname, targetserver = UnitFullName(unit)
		if targetserver == nil then
		
		else
			targetname = targetname..'-'..targetserver 
		end
		local health = UnitHealth(unit)
		local maxhealth = UnitHealthMax(unit)
		PvPGrid.playerinfos[targetname].maxhealth = maxhealth
		PvPGrid.playerinfos[targetname].curhealth = health
		for i=1, 15, 1 do
			local framename = 'enemyplayer'..i
			if self.playergrid[i] then
				if  self.playergrid[i].name == targetname then
					self.mainframe[framename].health:SetValue(health/maxhealth)
					--print('healthupdate '..targetname)
				end
			end	
		end
	end
end

function PvPGrid_OnEvent(self, event, ...)
	if event == 'ZONE_CHANGED_NEW_AREA' then
		PvPGrid:PvP_Zone_check()
	elseif event == "UPDATE_BATTLEFIELD_SCORE" then
		PvPGrid:onBG()
	elseif event == "UNIT_TARGET" then
		PvPGrid:target_check(...)
	elseif event == "UNIT_HEALTH_FREQUENT" then
		PvPGrid:update_health(...)	
	end
end

